releases/20170420035837/config/routes.rb
Rails.application.routes.draw do

  # Authentication
  get 'auth/:provider/callback', to: 'sessions#create'
  get 'auth/failure', to: redirect('/')
  get 'signout', to: 'sessions#destroy', as: 'signout'
  resources :sessions, only: [:create, :destroy]

  # Homepages
  root 'home#logged_in'
  get 'authenticate', to: 'home#logged_out'
  resource :home, only: [:logged_in, :logged_out]

  # Admin
  get :admin, to: 'admin#home'

  # Users
  resources :users do
    put :organization_enable, :organization_disable
  end

  # User roles
  resources :user_roles

  # Roles
  resources :roles

  # Organizations
  resources :organizations

  # Late Plates
  resources :late_plates

  # Meals
  resources :meals

  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end

releases/20170420035837/app/models/late_plate.rb
# == Schema Information
#
# Table name: late_plates
#
#  id              :integer          not null, primary key
#  day             :date             not null
#  completed       :boolean          default(FALSE), not null
#  meal_id         :integer          not null
#  user_id         :integer          not null
#  organization_id :integer
#  created_at      :datetime         not null
#  updated_at      :datetime         not null
#

class LatePlate < ApplicationRecord
  belongs_to :user, foreign_key: 'user_id'
  belongs_to :organization, foreign_key: 'organization_id'
  belongs_to :meal, foreign_key: 'meal_id'

  # Validation
  validates :day, presence: true

  validates :meal_id, presence: true

  validates :user_id, presence: true

  validates :completed, :inclusion => {:in => [true, false]}

  def requester_name
    User.find(self.user_id).full_name
  end

  def meal_name
    Meal.find(self.meal_id).meal_name
  end

  def better_date
    day.strftime("%m/%d/%Y")
  end

  def full_name
    "#{meal_name} on #{better_date}"
  end
end

releases/20170420035837/app/controllers/late_plates_controller.rb
class LatePlatesController < ApplicationController
  before_action :authorize_action

  def new
    @late_plate = LatePlate.new
  end

  def edit
    @late_plate = LatePlate.find(params[:id])
  end

  def create
    @late_plate = LatePlate.new(late_plate_params)
    @late_plate.day = DateTime.parse(late_plate_params[:day])

    if current_user
      @late_plate.user_id         = current_user.id
      @late_plate.organization_id = current_user.affiliated_organization
    end

    if @late_plate.save
      redirect_to action: "index"
    else
      render 'new'
    end
  end

  def update
    @late_plate = LatePlate.find(params[:id])

    if @late_plate.update(late_plate_params)
      redirect_to @late_plate
    else
      render 'edit'
    end
  end

  def index
    @late_plates = policy_scope(LatePlate).where(organization_id: current_user.affiliated_organization)

    sql = "SELECT *
             FROM late_plates
            WHERE meal_id
               IN (SELECT id
                     FROM meals
                    WHERE time > LOCALTIME
                 ORDER BY abs(extract(epoch from LOCALTIME - time))
                    LIMIT 1);"
    @next_meals_plates = LatePlate.find_by_sql(sql)
  end

  def show
    @late_plate = LatePlate.find(params[:id])
  end

  def destroy
    LatePlate.find(params[:id]).delete

    redirect_to late_plates_path
  end

  private

  def late_plate_params
    params.require(:late_plate).permit(
      :meal_id,
      :user_id,
      :organization_id,
      :day
    )
  end

  def authorize_action
    authorize LatePlate
  end
end

releases/20170420035837/app/helpers/late_plates_helper.rb
module LatePlatesHelper
end

releases/20170420035837/app/views/late_plates/_form.html.erb
<%= form_for @late_plate do |f| %>
  <% if @late_plate.errors.any? %>
    <div id="error_explanation">
      <h2>
        <%= pluralize(@late_plate.errors.count, "error") %> prohibited
        this late plate from being saved:
      </h2>
      <ul>
        <% @late_plate.errors.full_messages.each do |msg| %>
          <li><%= msg %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <div class="form-group">
    <%= f.label :meal_id %>
    <%= f.collection_select( :meal_id, Meal.all, :id, :meal_name, {prompt: "Meal"}, {:class=>'form-control'}) %>
  </div>

  <div class="form-group">
    <%= f.label :day %>
    <div class="input-group">
    <%= f.text_field :day, :id => "datepicker", :value => Date.today, :class=>'form-control' %>
    <span class="input-group-addon">
      <span class="glyphicon glyphicon-calendar"></span>
    </span>
  </div>
  </br>
  <div>
    <%= f.submit 'Submit', :class => 'btn btn-default' %>
  </div>
<% end %>

<script>
$('#datepicker').datetimepicker({
  format: "DD-MM-YYYY",
  minDate: moment(),
});
</script>

releases/20170420035837/app/views/late_plates/index.html.erb
<%= render 'layouts/header' %>

<div class="container theme-showcase">
  <div style="text-align:left;">
    <h1>
      Late Plates
    </h1>
    <h2>
      Next Meal Requests
      <span style="float:right;">
        <%= link_to "Make a Late Plate Request", new_late_plate_path(), :class => "btn btn-primary" %>
      </span>
    </h2>
    <table class="table">
      <tr>
        <th>Name</th>
        <th>Meal</th>
        <th>Day</th>
        <th>Completed</th>
        <th>Actions</th>
      </tr>
      <% @next_meals_plates&.each do |meal_request| %>
        <tr>
          <td><%= meal_request.requester_name %></td>
          <td><%= meal_request.meal_name %></td>
          <td><%= meal_request.day.strftime("%m/%d/%Y") %></td>
          <% if meal_request.completed %>
          <td>
            <div class="label label-success">Done</div>
          </td>
          <% else %>
          <td>
            <div class="label label-info">Not yet done</div>
          </td>
          <% end %>
          <td class="btn-group" role="group" aria-label="...">
            <% if current_user.id == meal_request.user_id %>
              <%= link_to "Delete", late_plate_path(meal_request),  method: :delete, :class => "btn btn-danger", data: { confirm: 'Delete late plate request?' } %>
            <% end %>
          </td>
        </tr>
      <% end %>
    </table>
    <% if current_user.late_plates.present? %>
    <h2>
      My Future Meal Requests
    </h2>
    <table class="table">
      <tr>
        <th>Name</th>
        <th>Meal</th>
        <th>Day</th>
        <th>Completed</th>
        <th>Actions</th>
      </tr>
      <% current_user.late_plates.each do |late_plate| %>
        <tr>
          <td><%= late_plate.requester_name %></td>
          <td><%= late_plate.meal_name %></td>
          <td><%= late_plate.day.strftime("%m/%d/%Y") %></td>
          <% if late_plate.completed %>
          <td>
            <div class="label label-success">Done</div>
          </td>
          <% else %>
          <td>
            <div class="label label-info">Not yet done</div>
          </td>
          <% end %>
          <td class="btn-group" role="group" aria-label="...">
            <%= link_to "Delete", late_plate_path(late_plate),  method: :delete, :class => "btn btn-danger", data: { confirm: 'Delete late plate request?' } %>
          </td>
        </tr>
      <% end %>
    </table>
    <% end %>
  </div>
</div>

<%= render 'layouts/footer' %>

releases/20170420035837/app/views/late_plates/new.html.erb
<%= render 'layouts/header' %>

<div class="container theme-showcase">
  <h1>New Late Plate Request
    <span style="float:right;">
      <%= link_to "Back to Late Plates", late_plates_path(), :class => "btn btn-primary" %>
    </span>
  </h1>
  <%= render 'form' %>
</div>

<%= render 'layouts/footer' %>